/* regTest.c */
/* be sure to compile this _without_ optimization, so the 
register variables are really put in registers, if possible:
*/
#include <stdio.h>
#include <assert.h>
#include "newthreads.h"


#define NumThreads 5

int ack[NumThreads];
Thread worker[NumThreads];


void main(int argc, char* argv[])
{
  int i;
  int startTime, endTime;
  void integerFunc(void*);
  void floatFunc(void*);

  init_newthreads(&argc, argv);

  /* print out the arguments */
  printf("%d: %d args\n", MyNodeNum, argc);
  for(i=0; i<argc; ++i){
        printf("%d: arg[%d] = %s\n", MyNodeNum, i, argv[i]);
  }

  /* print some stuff */
  for(i=0; i<NumThreads; ++i){
    ack[i] = 0;
    sprintf(worker[i].name, "integer[%d]", i);
    threadStart(&worker[i], integerFunc, (void*)i);
  }
  for(i=0; i<NumThreads; ++i){
    while(ack[i] == 0)    threadYield();
  }

  for(i=0; i<NumThreads; ++i){
    ack[i] = 0;
    sprintf(worker[i].name, "floater[%d]", i);
    threadStart(&worker[i], floatFunc, (void*)i);
  }
  for(i=0; i<NumThreads; ++i){
    while(ack[i] == 0)    threadYield();
  }

  nodeExit();
}


void floatFunc(void* arg)
{
  int id = (int)arg;
  float result;
  register float r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11, r12, r13,
             r14, r15, r16, r17, r18, r19, r20, r21, r22, r23, r24, r25,
             r26, r27, r28, r29, r30, r31;

    r1 = (float) id;
    r2 = (float) id;
    r3 = (float) id;
    r4 = (float) id;
    r5 = (float) id;
    r6 = (float) id;
    r7 = (float) id;
    r8 = (float) id;
    r9 = (float) id;
    r10 = (float) id;
    r11 = (float) id;
    r12 = (float) id;
    r13 = (float) id;
    r14 = (float) id;
    r15= (float) id;
    r16= (float) id;
    r17= (float) id;
    r18= (float) id;
    r19= (float) id;
    r20 = (float) id;
    r21 = (float) id;
    r22 = (float) id;
    r23 = (float) id;
    r24 = (float) id;
    r25 = (float) id;
    r26 = (float) id;
    r27 = (float) id;
    r28 = (float) id;
    r29 = (float) id;
    r30 = (float) id;
    r31 = (float) id;

  result = r1+ r2+ r3+ r4+ r5+ r6+ r7+ r8+ r9+ r10+ r11+ r12+ r13+
             r14+ r15+ r16+ r17+ r18+ r19+ r20+ r21+ r22+ r23+ r24+ r25+
             r26+ r27+ r28+ r29+ r30+ r31;

  printf("Hello, world from %d, result = %f, check = %d\n", id, result, 31 * id)
;
  fflush(stdout);
  threadYield();

  result = r1+ r2+ r3+ r4+ r5+ r6+ r7+ r8+ r9+ r10+ r11+ r12+ r13+
             r14+ r15+ r16+ r17+ r18+ r19+ r20+ r21+ r22+ r23+ r24+ r25+
             r26+ r27+ r28+ r29+ r30+ r31;
  printf("Hello, world from %d, result = %f, check = %d\n", id, result, 31 * id)
;
  threadYield();
  ack[id] = 1;
  threadExit();
}

void integerFunc(void* arg)
{
  int id = (int)arg;
  int result;
  register int r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11, r12, r13,
             r14, r15, r16, r17, r18, r19, r20, r21, r22, r23, r24, r25,
             r26, r27, r28, r29, r30, r31;

    r1 = id;
    r2 = id;
    r3 = id;
    r4 = id;
    r5 = id;
    r6 = id;
    r7 = id;
    r8 = id;
    r9 = id;
    r10 = id;
    r11 = id;
    r12 = id;
    r13 = id;
    r14 = id;
    r15= id;
    r16= id;
    r17= id;
    r18= id;
    r19= id;
    r20 = id;
    r21 = id;
    r22 = id;
    r23 = id;
    r24 = id;
    r25 = id;
    r26 = id;
    r27 = id;
    r28 = id;
    r29 = id;
    r30 = id;
    r31 = id;

  result = r1+ r2+ r3+ r4+ r5+ r6+ r7+ r8+ r9+ r10+ r11+ r12+ r13+
             r14+ r15+ r16+ r17+ r18+ r19+ r20+ r21+ r22+ r23+ r24+ r25+
             r26+ r27+ r28+ r29+ r30+ r31;

  printf("Hello, world from %d, result = %d, check = %d\n", id, result, 31 * id)
;
  fflush(stdout);
  threadYield();

  result = r1+ r2+ r3+ r4+ r5+ r6+ r7+ r8+ r9+ r10+ r11+ r12+ r13+
             r14+ r15+ r16+ r17+ r18+ r19+ r20+ r21+ r22+ r23+ r24+ r25+
             r26+ r27+ r28+ r29+ r30+ r31;
  printf("Hello, world from %d, result = %d, check = %d\n", id, result, 31 * id)
;
  threadYield();
  ack[id] = 1;
  threadExit();
}
